/*
 *  Sun Nov 27 00:41:09 EET 2005
 *
 *  MDR-150 RVALVE/etc amateur radio application.
 *
 *  No changes here, appending more cfg.variables is fine.
 *  Ei muutoksia, vain muuttujien lisyst cfg:n loppuun.
 *  Inga vxlingar hr, mer p sluten av cfg r bra.
 *  Nicht ndem. Hinzufgen 'cfg' ist gut.
 *
 *  Refer to variables through cfg.whatnot, nothing fancy.
 *  Edit them through cfgparm array(s).
 *  Before using, if config_size tells it was written by
 *  older software, zero out the missing part and and update
 *  config_size. No rush to save it.
 *
 *  BOOL and TAB are byte variables.
 */

#define CFG_MAGIC_1 0x7A800D01
#define CFG_MAGIC_2 0x7A800D02

/* keep in sync with tab_personality[] */
enum {
	PERSONALITY_VOICE,
	PERSONALITY_TRACKER,
	PERSONALITY_KISS,
	PERSONALITY_PEATER,
	PERSONALITY_SCANNER,
};

/* keep in sync with tab_gps[] XXX this asks for some machinations */
enum  {
	GPS_GENERIC,
	GPS_GARMIN,
	GPS_MAGELLAN,
	GPS_AISIN,
	GPS_SIRF,
	GPS_TRIPMATE,
	GPS_EARTHMATE,
	GPS_ZODIAC,
	GPS_SEATALK,
	GPS_ONCORE,
};

/* this never changes, just grows. try to keep short-aligned for fun */

struct channel {
	dword freq;
	dword tx_freq;
	byte  pad[8];       /* this is all you get to expand into */
};

extern
struct nv {
	word  nv_size;
} nv;

extern
struct cfg {
	word  config_size;
	dword cfg_magic_1;

	dword freq;            /* kHz */
	dword tx_freq;         /* kHz, usually 0 = simplex */
	dword rx_if_offset;    /* kHz, subtracted */
	word  squelch;         /* rssi level */
	word  rssi_1led;
	word  rssi_2led;
	word  rssi_3led;

	byte  tx_power;        /* 0 ... 3 meaning 5W ... 50mW */
	byte  personality;
	byte  use_busy;        /* instead of rssi */
	byte  persistence;

	byte  mycall[12];      /* OHnABC-15 regular C-string */

	word  slottime;

	word  ttybaud;         /* 0 is 19200 (set by loader, not us) */

	word  squelch_delay;   /* squelch opening delay */
	word  squelch_tail;    /* squelch closing delay */
	word  squelch_bilevel; /* rssi level for snappy squelch */

	byte  myalias[12];     /* OHnABC-15 regular C-string */

	word  pll_delay;
	word  pwr_delay;

	byte  autobeep;        /* automatic 1750Hz if squelched and duplex */
	byte  autoscan;

	struct channel channel[25]; /* not visible in cfg_general[] */

	word  txlimit;
	word  ttylines;

	byte  rfpasswd[16];        /* C-string */

	word  track_distance;
	word  track_interval;
	byte  digipath[10 * 8];    /* C-string */

	byte  aprs_dst[12];        /* OHnABC-15 regular C-string */
	word  mysymbol;            /* direct code */
	byte  mysymbol_JUNK_[10];   /* ...  and 10 characters junk */

	byte  mydomain[12];        /* OHnABC-15 regular C-string */

	byte  gps;
	byte  waypoints;

	byte  use_mic_e;        /* instead of ascii APRS format */
	byte  mic_e_msg;
	byte  mic_e_ssid;

	byte  ptt_packet;
	byte  ptt_origin;

	word  scan_tail;       /* scanner linger delay, sec */
	word  idle_time;       /* delay to scanner autostart, sec */

	byte  afsk_type_RETIRED;
	byte  app_port;

	byte  align_to_word;

	word  data_delay;

	byte  gps_lat[sizeof("06103.52,N")];
	byte  gps_lon[sizeof("02806.21,E")];

	byte  waypoint_tidy[20];

	byte  profile_tag[16];  /* XXX this is handled little bit special */

	word  track_limiter;
	word  track_turnslope;

	word  kiss_trick;

	word  track_sideg_RETIRED;

	word  ctcss;

	/* sizeof(cfg) == 696 at this point */

	byte  myname[10];
	byte  mytype;

	byte  use_compression;   /* if ascii APRS format */

	byte  target_type;
	byte  target_name[10];
	byte  target_symbol_RETIRED_[12];   /* gnaah cannot be bothered */

	bool  target_comment;

	byte  altnet[10];

	word  waypoint_area;

	word  long_area;
	word  long_time;
	byte  longpath[10 * 8];    /* C-string */

	word  track_highg;
	word  track_lowg;

	bool  use_softdcd;

	byte  tracker_digi;
	word  digi_area;

	/* sizeof(cfg) == 834 at this point */

	word  relay_viscosity;

	word  lobatt;

	bool  do_telemetry_RETIRED;
	bool  faith_in_pll;

	word  anemoscale;

	bool  do_onewire_RETIRED;
	byte  telemetry_bytes_RETIRED_[7];

	word  battscale;

	bool  blind_octopus;

	byte  short_comment[9];
	byte  long_comment[36];

	bool  send_altitude;

	/* 902 and counting */

	byte  telemetry_format[5 + 8 + 7];

	word  radio_range;

			/* 924 and counting */

	dword cfg_magic_2;

			/* 928 and counting */

	word  target_symbol;             /* direct code */

	bool  nmea_regen;
	byte  lcd;
	byte  manipulator;

	byte  bullgroups[32];

	byte  chatboard;

	bool  tx_lockout;

	byte  rn3_function;

	word  vaneoffset;
	bool  wx_dump;

	/* sizeof(cfg) == 972 at this point */

	word  dupe_age;
	bool  wide_is_trace;
	bool  bootflag;        /* XXX this is handled specially */

	byte  event_packet[80];

	/* always add to the line above this comment. */
} cfg;

#if INTEREST_IN_CFG > 0

/* ordering etc can change at will below */

struct cfgparm {
	enum {
		CFG_NONE,
		CFG_BOOL, CFG_BYTE, CFG_WORD, CFG_LONG, CFG_STR,
		CFG_TAB, CFG_FREQ, CFG_APRSYM
	} type;
	char *name;
	void *address;
	word size;
	dword defval;
	byte **optlist;
	char *info;
	byte group;
#if 0
	dword (*getset)(bool is_set, struct cfgparm *); /* before get, after set */
#endif
};

#if INTEREST_IN_CFG > 1

#define MISC_CFG(typ, nam, def, info) { typ, \
	#nam, &cfg.nam, sizeof(cfg.nam), def, NULL, info, GROUP }

#define MISC_TAB(nam, def, tab, info) { CFG_TAB, \
	#nam, &cfg.nam, sizeof(cfg.nam), def, tab, info, GROUP }

#define MISC_DYN(typ, nam, getset, info) { typ, \
	#nam, NULL, 0, 0, NULL, info, GROUP, getset }

#define MISC_STR(nam, def, info)    MISC_CFG(CFG_STR,  nam, def, info)
#define MISC_BOOL(nam, def, info)   MISC_CFG(CFG_BOOL, nam, def, info)
#define MISC_BYTE(nam, def, info)   MISC_CFG(CFG_BYTE, nam, def, info)
#define MISC_WORD(nam, def, info)   MISC_CFG(CFG_WORD, nam, def, info)
#define MISC_LONG(nam, def, info)   MISC_CFG(CFG_LONG, nam, def, info)
#define MISC_FREQ(nam, def, info)   MISC_CFG(CFG_FREQ, nam, def, info)

#define APRS_SYM(nam, def, info)    MISC_CFG(CFG_APRSYM, nam, ('/' << 8) | (def), info)

/* Most of these tables have magic ordering */

static byte
	*tab_personality[] = {
	     "Voice", "Tracker", "KISS", "Digipeater", "Scanner", NULL },
	*tab_tx_power[]    = { "5W", "1W", "200mW", "50mW", NULL },
	*tab_gps[]         = { "generic", "Garmin",   "Magellan",  "Aisin",
	                       "SiRF",    "TripMate", "EarthMate", "Zodiac",
	                       "SeaTalk", "Oncore",   NULL },
	*tab_lcd[]         = { "none",
	                       "1x16", "2x16", "4x16",
	                       "1x20", "2x20", "4x20",
	                       "2x24", "2x40", "1x8",
	                       NULL },
	*tab_app_port[]    = { "1", "2", "auto", NULL },
	*tab_mic_e_ssid[]  = {
	     "none",       "wide-1",     "wide-2",    "wide-3",
	     "wide-4",     "wide-5",     "wide-6",    "wide-7",
	     "north",      "south",      "east",      "west",
	     "north+wide", "south+wide", "east+wide", "west+wide", NULL },
	*tab_mic_e_msg[]   = {
	     "off-duty",  "en-route", "in-service", "returning",
	     "committed", "special",  "priority",   "emergency",
	     "0", "1", "2", "3", "4", "5", "6", NULL },
	*tab_ptt_origin [] = { "DTR2", "MISO", "none", NULL },
	*tab_manipulator[] = { "none", "*", "DTR2", NULL },
#if 0
	*tab_chatboard  [] = { "none", "Ericsson", "Aplicom", "4800", "1200", NULL },
#endif
	*tab_ptt_packet [] = { "off", "id", "MIC-E", NULL },
	*tab_mytype     [] = { "normal", "object", "item", NULL },
	*tab_target_type[] = { "none", "object", "item", NULL },
	*tab_rn3function[] = { "none", "weather", "keypad", NULL },
	*tab_tracker_digi[] = { "none", "relay", "wide", NULL };


struct cfgparm cfg_general[] = {

#define GROUP ~0

	MISC_STR(profile_tag,        0, "name of this set of parameters"),

	MISC_TAB(personality,        0, tab_personality, "my mission"),
	MISC_WORD(ttybaud,           0, "0: 19200 or any personality specific default"),
	MISC_WORD(ttylines,         24, "pause long listings. 0=unlimited"),
	MISC_TAB(app_port,           0, tab_app_port, "gps or kiss attached to serial 1 or 2"),
	MISC_WORD(lobatt,            0, "engine monitor. wire +VB/3 to AN7"),

	MISC_FREQ(freq,         145200, "rx frequency, tx too if tx_freq=0"),
	MISC_FREQ(tx_freq,           0, "0=simplex, see 'freq'"),
	MISC_BOOL(tx_lockout,    FALSE, "+12v in RTS1 overrides lockout"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_VOICE) | (1 << PERSONALITY_SCANNER)

	MISC_WORD(ctcss,             0, "deciHz, like 1188 = 118.8. 0=off"),

	MISC_BOOL(autoscan,      FALSE, "voice p. scans channels when idle"),
	MISC_WORD(idle_time,        30, "seconds from ptt/squelch to autoscan"),
	MISC_WORD(scan_tail,         5, "seconds to linger before resuming scan"),
	MISC_BOOL(autobeep,       TRUE, "automatic 1750Hz burst if duplex-voice"),
	MISC_TAB(ptt_packet,         0, tab_ptt_packet, "packet sent after voice ptt"),

#undef  GROUP
#define GROUP ~0

	MISC_FREQ(rx_if_offset,  21400, "normally 21400/2m, 44900/UHF"),
	MISC_TAB(tx_power,           0, tab_tx_power, "transmitter power"),
	MISC_TAB(ptt_origin,         0, tab_ptt_origin, "MISO needs +5VDD pullup"),
	MISC_WORD(pll_delay,       100, "msecs to wait for PLL lock"),
	MISC_WORD(pwr_delay,       100, "msecs to wait for power to rise"),
	MISC_WORD(data_delay,      100, "msecs to wait before sending afsk"),
	MISC_BOOL(use_busy,      FALSE, "use BUSY input for dcd and squelch. not RSSI"),
	MISC_BOOL(use_softdcd,   FALSE, "use software hack for dcd. not BUSY or RSSI"),
	MISC_WORD(squelch,         100, "squelch open/close level. see rssi with 'stat'"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_VOICE) | (1 << PERSONALITY_SCANNER)

	MISC_WORD(squelch_delay,   100, "msec of opening delay"),
	MISC_WORD(squelch_tail,    100, "msec of hang delay"),
	MISC_WORD(squelch_bilevel, 200, "no hang delay if rssi was over this"),
	MISC_WORD(rssi_1led,       100, "signal strength to leds"),
	MISC_WORD(rssi_2led,       200, "signal strength to leds"),
	MISC_WORD(rssi_3led,       300, "signal strength to leds"),

#undef  GROUP
#define GROUP ~0

	MISC_STR(mycall,             0, "callsign and ssid, like OHnABC-n"),
	MISC_STR(myalias,            0, "alias for digipeater, like RELAY. ssid usable"),
	MISC_STR(mydomain,           0, "kind of admin alias, for remote cfg. ssid usable"),
	MISC_STR(rfpasswd,           0, "password for remote cfg. unique mycall suggested"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_TRACKER)

	MISC_TAB(mytype,             0, tab_mytype, "what kind of animal I am. see myname"),
	MISC_STR(myname,             0, "object/item name. A-Z 0-9 only suggested"),
	APRS_SYM(mysymbol,         '>', "2 characters or name. try help symbols"),
	MISC_STR(bullgroups,         0, "bulletin groups, blank separated"),

#undef  GROUP
#define GROUP ~0

	MISC_BYTE(persistence,      64, "0 polite, 255 pig"),
	MISC_WORD(slottime,        100, "msec. channel access timing"),
	MISC_WORD(txlimit,         300, "bytes (approx). limit a single keydown"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_KISS)

	MISC_WORD(kiss_trick,        0, "'token ring'. 0 disable. 1-15 sets also portnum"),

#undef  GROUP
#define GROUP (1 << PERSONALITY_TRACKER)

	MISC_WORD(track_distance, 1852, "meters travelled between reports. 0=disable"),
	MISC_WORD(track_interval, 1801, "seconds between reports. 0=disable"),
	MISC_WORD(track_limiter,    30, "seconds between reports, at minimum"),
	MISC_WORD(track_turnslope,3600, "km/h factor of CornerPegging. 0=disable"),
	MISC_WORD(track_highg,      40, "sideways acceleration in turn. 0=disable"),
	MISC_WORD(track_lowg,       10, "sideways acceleration after turn"),
	MISC_STR(digipath,           0, "normal tracker digipath. blank separated"),
	MISC_STR(longpath,           0, "far reaching tracker digipath. blank separated"),
	MISC_WORD(long_area,     10000, "meters between longpath reports. 0=disable"),
	MISC_WORD(long_time,      3600, "seconds between longpath reports. 0=disable"),
	MISC_STR(long_comment,       0, "appended to longpath reports"),
	MISC_STR(short_comment,      0, "appended to normal reports"),
	MISC_STR(aprs_dst,           0, "destination of aprs reports, default APRS-0"),
	MISC_STR(altnet,             0, "required destination in incoming packets. * and ? wildcards. default=*"),
	MISC_TAB(target_type,        0, tab_target_type, "is the target object or item ? none=disable target report"),
	MISC_STR(target_name,        0, "object/item name of GPS GoTo. * means put unique digit. default=wpt_name"),
	APRS_SYM(target_symbol,    'c', "2 characters or name. try help symbols"),
	MISC_BOOL(target_comment,  FALSE, "show active Goto in report"),
	MISC_BOOL(use_compression, FALSE, "base91 compression when possible"),
	MISC_WORD(radio_range,      20, "kilometers. in stationary compressed reports"),
	MISC_BOOL(send_altitude,   FALSE, "report altitude if possible"),
	MISC_STR(event_packet,       0, "TAPR-format. sent when RTS2 changes"),
	MISC_TAB(gps,                0, tab_gps, "type of gps used"),
	MISC_STR(gps_lat,            0, "default latitude. like 6103.52,N"),
	MISC_STR(gps_lon,            0, "default longitude. like 2806.21,E"),
	MISC_BOOL(nmea_regen,    FALSE, "relay some sentences back to asy"),
	MISC_BOOL(waypoints,     FALSE, "reports to gps wpts"),
	MISC_STR(waypoint_tidy,      0, "blank separated prefixes peeled from wpt names. -l lcase -a as-is -F hex_ssid"),
	MISC_WORD(waypoint_area,     0, "kilometers. reports far away are ignored"),

	MISC_BOOL(use_mic_e,     FALSE, "send MIC-E formatted report"),
	MISC_TAB(mic_e_ssid,         0, tab_mic_e_ssid, "MIC-E path"),
	MISC_TAB(mic_e_msg,          0, tab_mic_e_msg,  "MIC-E status"),

	MISC_TAB(tracker_digi,       0, tab_tracker_digi, "hesitant RELAY or normal digi. myalias RELAY suggested"),
	MISC_WORD(relay_viscosity,  10, "seconds. wait other RELAY to act first"),
	MISC_WORD(dupe_age,         30, "seconds. ignore duplicates"),
	MISC_WORD(digi_area,        10, "kilometers. reports far away are ignored"),
	MISC_BOOL(wide_is_trace, FALSE, "more verbose digipeat of WIDEn-N"),
	MISC_STR(telemetry_format,   0, "telemetry mapping. 5+8+N chars. no default"),
	MISC_BOOL(faith_in_pll,  FALSE, "ignore UNLOCK. AN5 generic A/D"),
	MISC_WORD(battscale,       150, "scale A/D to deciV. see 'batt'"),
	MISC_WORD(anemoscale,     2237, "scale pulse/msec to mph"),
	MISC_WORD(vaneoffset,        0, "wind vane offset"),
	MISC_TAB(lcd,                0, tab_lcd, NULL),
	MISC_TAB(manipulator,        0, tab_manipulator, NULL),
#if 0
	MISC_TAB(chatboard,          0, tab_chatboard, NULL),
#endif
	MISC_TAB(rn3_function,       0, tab_rn3function, "what is wired at RN3"),
	MISC_BOOL(wx_dump,       FALSE, "weather data to asy"),

#undef  GROUP
};

#endif /* > 1 */
#endif /* > 0 */

