
; IC2 aka PGP1 aka RTSB
; TCNT rate is 1'048'576 Hz ~ 953.7 nsec
; TOF 16 Hz exactly

	include regs.inc

PIN       equ  02h  ; PGP1

TO_V      equ  80h  ; XXX XXX XXX XXX 92h IVBA:1001, but adjusted hipri
IC2_V     equ  84h  ; IVBA:0010

TOF       equ  80h  ; TFLG2 and TMSK2
IC2F      equ  02h  ; TFLG1 and TMSK1

IC2edges  equ  0Ch
IC2fedge  equ  08h
IC2redge  equ  04h

	;------------------------------------------------------------
	section .bankf
	align 1

tcnt_ext   ds.w 2           ; overflow after 8.5 years

	;------------------------------------------------------------
	section .inthand
	align 1

	;------------------------------------------------------------

TO_int
	pshm d,k
	ldab # 0FFh
	tbek

	incw tcnt_ext + 2
	bne  L1
	incw tcnt_ext + 0
L1
	bclr TFLG2, # TOF
	pulm d,k
	rti

IC2_int

	pshm d,k
	ldab # 0FFh
	tbek

	ldd  TIC2              ; 
	bclr TFLG1, # IC2F     ;

	pulm d,k
	rti

	;------------------------------------------------------------
	section .text
	align 1

	global _icap2_init

_icap2_init

	pshm k,ccr
	orp  # 000E0h

	ldd  # TO_int
	std  TO_V

	ldd  # IC2_int
	std  IC2_V

	ldab # 0FFh
	tbek                   ; switch EXT

	bclr DDRGP, # PIN      ; pin is input

	bclr TCTL2, # IC2edges ; 00 = capture disabled
	bset TCTL2, # IC2fedge ; 10 = low-going edge interrupts

	bclr TFLG1, # IC2F     ; forget stale capture
	bset TMSK1, # IC2F     ; enable IC2 interrupt

	bclr TFLG2, # TOF      ; forget stale overflow
	bset TMSK2, # TOF      ; enable TO interrupt

	pulm k,ccr             ; restore IPL
	rts

