
;
;  MB1504, 12.8 MHz
;
;  recommended steps
;   5.000 kHz ~ S=2560
;   6.250 kHz ~ S=2048
;
;  SW S14 S13  ... S2 S1 C
;  16 bits in total
;  SW=0 first, C=1 last
;  SW=0 ~ 64
;  SW=1 ~ 32
;
;  S18 S17 ... S2 S1 C
;  19 bits in total
;  C=0 last
;  11 bits N, 7 bits A (with one zero in 64 mode)
;
; XXX blurb about radio_control() bits
; XXX POWEL has nothing to do with POWer. Just the un-Hi-Z of 4094 control reg

	section .text
	align 1

delay
	pshm x,y,z
	pulm x,y,z
	rts

bit
	bcs  bit_1
bit_0
    bclr 0FA19h, #08h
	bra  clockit
bit_1
    bset 0FA19h, #08h
clockit
	bsr  delay
    bset 0FA19h, #04h
	bsr  delay
    bclr 0FA19h, #04h
	rts

strobe_pll
	bsr  delay
    bset 0FA19h, #10h
	bsr  delay
    bclr 0FA19h, #10h
	rts

strobe_sr
	bsr  delay
    bset 0FA19h, #02h
	bsr  delay
    bclr 0FA19h, #02h
	rts

	;--------------------------------
	global _synth_R

_synth_R             ; (word R_divider_in_E)  2048 for 6.25 kHz

	pshm k
	ldab #0FFh
	tbek             ; address the SFRs

	lbsr bit_0       ; select swallow counter 64
	role             ; left justify E
	role             ; ... two bits
	ldab #14         ; 14 bits of R
L1
	role             ; MSbit first
	lbsr bit
	decb
	bne  L1
	lbsr bit_1       ; control bit for reference load
	lbsr strobe_pll

	pulm k
	rts

	;--------------------------------
	global _synth_NA

_synth_NA             ; (unsigned long 17_bits_of_channel_in_ED)

	; 17 LSbits of ED into left-justified EA

	xgde              ; 16 LSbits in E, MSbit in B.0
	rorb              ; MSbit in carry
	rore              ; 16 MSbits in E, LSbit in carry
	rora              ; LSbit in position, too. B free for use

	pshm k
	ldab #0FFh       ; address the SFRs
	tbek

	ldab #11          ; 11 bits of N
L2
	asla              ; A still has valid bits at this point
	role              ; MSbit first
	lbsr bit
	decb
	bne  L2
	lbsr bit_0        ; one pad bit in swallow register
	ldab #6           ; 6 bits of A
L3
	role              ; MSbit first, A is dont care at this point
	lbsr bit
	decb
	bne  L3
	lbsr bit_0        ; control bit 0
	lbsr strobe_pll

	pulm k
	rts


	;--------------------------------
	global _radio_control

_radio_control       ; (byte sr_byte_in_E)  RFCMD_xxx

	pshm k
	ldab #0FFh
	tbek             ; address the SFRs

	ted              ; control byte in B
	ldaa # 8         ; 8 bits
L4
	rolb             ; MSbit first
	lbsr bit
	deca
	bne  L4
	lbsr strobe_sr

	; this is clear at start, is it ?, and then just
	; stays on forever. Output Enable of the 4094 shifter register

	bset 0FA19h, # 20h  ; POWEL = PORTF.5 up XXX real misnomer.

	pulm k
	rts


	;--------------------------------
	global _synth_locked
	global _busy_channel

read_port_ADA

	pshm k
	ldab # 0FFh
	tbek

	ldab 0F707h
	clra                 ; sane return value

	pulm k
	rts

_synth_locked

	bsr  read_port_ADA
	comb                  ; flip UNLOCK to "LOCK"
	andb # 20h
	rts

_busy_channel

	bsr  read_port_ADA
	andb # 08h            ; BUSY
	rts

	;--------------------------------
	global _tx_power

_tx_power

	pshm k
	ldab # 0FFh
	tbek

	; 0=5W, 1=1W, 2=200mW 3=qrpp

	bset 0FA19h, # 80h + 40h ; lowest power first

	cpe  # 3                 ; if 3 or more, we are done
	bcc  L7
	lsre                     ; lsbit
	bcs  L6
	bclr 0FA19h, # 40h       ; POWL
L6
	lsre                     ; next bit
	bcs  L7
	bclr 0FA19h, # 80h       ; POWM
L7
	pulm k
	rts


	end
