
;-----------------------------------------------------------
	section .text
	align 1

;-----------------------------------------------------------
	global _call_near_ptr

_call_near_ptr

	; rts pops PK, then PC, then PK:PC -= 2

	aie  #2       ; adjustment for the wierd rts
	pshm e,ccr    ; E is pushed first (the pointer), CCR then (PK)
	tde           ; one arg available
	rts           ; effectively a jump


	; small model assumed, K not saved

	global _setjmp

_setjmp

	tex           ; env[]

	pulm e,d      ; peek PK and PC (jsr offset not fixed)

	stz  0,x      ; iz    frame of caller
	sts  2,x      ; sp    bare stack with no pk:pc
	ste  4,x      ; pk
	std  6,x      ; pc    could be pc:pk, but it does not matter

	pshm e,d      ; put them back for the first return

	clrd          ; return (0);
	rts


	global _longjmp

_longjmp

	tex           ; env[]
	tdy           ; return value

	ldz  0,x      ; iz    frame
	lds  2,x      ; sp    stack changes, bare stack now
	lde  4,x      ; pk
	ldd  6,x      ; pc

	pshm e,d      ; return address to stack (with jsr offset)

	tyd           ; return (1);
	rts

;-----------------------------------------------------------
	global _EDIV

_EDIV             ; word EDIV(long_dividend_ED, word_divisor, &word_remainder)

	tsx
	ldx  4,x      ; divisor
	ediv          ; E:D / IX to IX, remainder to D
	xgdx          ; result to D, remainder to IX

	tsy
	ldy  6,y      ; pointer to remainder
	beq  L9       ; could be NULL
	stx  0,y      ; store remainder
L9
	rts

	global _EMUL        ; dword EMUL(word, word)

_EMUL
	emul                ; ED = E * D
	rts

	global _EDIVx       ; dword EDIVx(dword dvdnd, word divsr, word *prem)

_EDIVx

	xgde                ; swap dividend words, D is HIW(dividend), E LOW()
	tsx
	ldx  4,x            ; get divisor
	idiv                ; D / IX to IX, remainder to D
	txy                 ; save HIW(result)
	xgde                ; E is 1st remainder and D LOW(dividend)
	tsx
	ldx  4,x            ; get divisor again
	ediv                ; ED / IX to IX, remainder to D
	xgdx                ; D is LOW(result), IX is remainder
	xgey                ; and the saved HIW(result) in final position
	tsy
	ldy  6,y            ; get prem
	beq  L1             ; if prem is NULL
	stx  0,y            ; else store remainder
L1
	rts

	global _EMULx

_EMULx            ; long EMULx(long ED, word)  ML * X = M * X * 0x10000 + L * X

	tsx           ; use IX for stacked arg

	xgdy          ; save L in Y for a while
	ldd  4,x      ; get X from stack
	emul          ; M * X to E:D  ---  fits in D (overflows ignored XXX)

	xgdy          ; save M * X and get L back to D

	lde  4,x      ; get X from stack, again
	emul          ; X * L to E:D --- LSWord is ready in D

	xgdy          ; save LSWord, get M * X to D
	ade           ; MSWord is ready in E. result E:Y

	xgdy          ; fix proper return in E:D
	rts

	global _muldiv

_muldiv           ; word muldiv(word value_e, word multiplier_d, word divisor)

	tsx
	ldx  4,x      ; divisor
	emul          ; E:D = E * D
	ediv          ; IX = E:D / IX, remainder to D
	xgdx          ; result to D, remainder to IX
	rts

;-----------------------------------------------------------
	global _LSRx

_LSRx              ; void LSRx(long *E, word numbits_D) logical shift right

	tstd
	beq  LSRx_out  ; shifting 0 bits is quick

	xgey           ; long at 0,Y
	xgdx           ; numbits in X

	lde  0,y
	ldd  2,y

	; tbd place to shortcut shift by 16 - not used yet

	cpx  # 8       ; shortcut a byte ?
	bcs  LSRx_loop

	clra
	ldab 0,y
	tde
	ldd  1,y

	aix  #-8
	beq  LSRx_done ; exactly 8, nothing more to do

LSRx_loop
	lsre
	rord           ; shifted one bit
	aix  #-1
	bne  LSRx_loop ; more ?

LSRx_done
	ste  0,y
	std  2,y

LSRx_out
	rts           ; long return in E:D


	global _ASLx

_ASLx             ; void ASLx(long *E, word numbits_D) shift left

	tstd
	beq  ASLx_out ; nothing to do

	xgey          ; long at 0,Y
	xgdx          ; numbits in X

	lde  0,y
	ldd  2,y

	; tbd place to shortcut shift by 16 - not used yet
	; tbd place to shortcut shift by 8 - not used yet

ASLx_loop
	asld
	role          ; shifted one bit
	aix  #-1      ; more ?
	bne  ASLx_loop

ASLx_done
	ste  0,y
	std  2,y

ASLx_out
	rts           ; long return in E:D



;-----------------------------------------------------------
	global _read_ram, _read_register, _read_eepage
	global _read_AN1, _read_AN3, _read_AN5, _read_AN7, _read_AN7_batt
	global _read_PORTQS
	global _read_PACTL
	global _read_RSSI

read_it_from_FF
	ldab #0FFh
read_it
	pshm k
	tbxk
	ldd  0,x
	pulm k
	rts

_read_ram
	tex
	ldab #0
	bra  read_it

_read_eepage
	tex
	ldab #2
	bra  read_it

_read_register
	tex
	bra  read_it_from_FF

_read_PORTQS
	ldx  #0FC14h            ; as a word
	bra  read_it_from_FF

_read_PACTL
	ldx  #0F90Ch
	bra  read_it_from_FF

_read_RSSI
	ldx  #0F712h         ; RJURR1
	bra  read_it_from_FF
_read_AN1
	ldx  #0F732h         ; left justified unsigned result reg 1
	bra  read_it_from_FF

_read_AN3
	ldx  #0F736h         ; left justified unsigned result reg 3
	bra  read_it_from_FF

_read_AN5
	ldx  #0F73Ah         ; left justified unsigned result reg 5
	bra  read_it_from_FF

_read_AN7
	ldx  #0F73Eh         ; left justified unsigned result reg 7
	bra  read_it_from_FF

_read_AN7_batt
	bsr _read_AN7        ; live E survives, D gets AN7
	emul                 ; ED = battscale_still_in_E * ad_value_in_D
	ted                  ; D = decivolts
	rts


;-----------------------------------------------------------

PORTGP equ 0F907h
PORTQS equ 0FC15h

	global _read_inputs
	global _DTR1_pin, _DTR2_pin, _RTS1_pin, _RTS2_pin

_read_inputs
	pshm k
	ldab # 0FFh
	tbek

	clrd
	brclr PORTGP, # 02h, L70   ; RTSB
	orab  # 1
L70
	brclr PORTQS, # 10h, L71   ; DTRB
	orab  # 2
L71
	brclr PORTQS, # 40h, L72   ; RTSA
	oraa  # 1
L72
	brclr PORTQS, # 20h, L73   ; DTRA
	oraa  # 2
L73
	pulm k
	rts

in_pins
	pshm k
	ldab # 0FFh
	tbek
	ldab PORTQS
	pulm k
	clra
	rts

_RTS1_pin
	bsr  in_pins
	andb # 40h
	beq  ret_pin
	bra  ret_pin_1

_RTS2_pin
	bsr  in_pins
	andb # 02h
	beq  ret_pin
	bra  ret_pin_1

_DTR1_pin
	bsr  in_pins
	andb # 20h
	beq  ret_pin
	bra  ret_pin_1

_DTR2_pin
	bsr  in_pins
	andb # 10h
	beq  ret_pin
ret_pin_1
	ldab # 1
ret_pin
	rts



	global _DCD1_pin, _CTS1_pin
	global _DCD2_pin, _CTS2_pin
	global _DSR1_pin

_DCD1_pin
	pshm k
	ldab # 0FFh
	tbek
	tste
	beq  L80
	bset PORTGP, # 40h   ; DCD1 high
	pulm k
	rts
L80
	bclr PORTGP, # 40h   ; DCD1 low
	pulm k
	rts

_CTS1_pin
	pshm k
	ldab # 0FFh
	tbek
	tste
	beq  L82
	bset PORTGP, # 04h   ; CTS1 high
	pulm k
	rts
L82
	bclr PORTGP, # 04h   ; CTS1 low
	pulm k
	rts

_DCD2_pin
	pshm k
	ldab # 0FFh
	tbek
	tste
	beq  L84
	bset PORTGP, # 80h   ; DCD2 high
	pulm k
	rts
L84
	bclr PORTGP, # 80h   ; DCD2 low
	pulm k
	rts

_CTS2_pin
	pshm k
	ldab # 0FFh
	tbek
	tste
	beq  L86
	bset PORTGP, # 08h   ; CTS2 high
	pulm k
	rts
L86
	bclr PORTGP, # 08h   ; CTS2 low
	pulm k
	rts

_DSR1_pin
	pshm k
	ldab # 0FFh
	tbek
	tste
	beq  L87
	bset PORTGP, # 10h   ; DSR1 high
	pulm k
	rts
L87
	bclr PORTGP, # 10h   ; DSR1 low
	pulm k
	rts

;-----------------------------------------------------------
	global _tx_led, _afsk_tx_led, _afsk_rx_led
	global _green_leds

PORTC equ 0FA41h

LEDS_ENTER	MACRO
	pshm k
	ldab # 0FFh
	tbek
	ENDM

LEDS_EXIT	MACRO
	pulm k
	rts
	ENDM

_tx_led
	LEDS_ENTER
	tste
	beq  L50
	bset PORTC, # 01h ; top left
	LEDS_EXIT
L50
	bclr PORTC, # 01h ; top left
	LEDS_EXIT

_afsk_tx_led
	LEDS_ENTER
	tste
	beq  L51
	bset PORTC, # 02h ; middle left
	LEDS_EXIT
L51
	bclr PORTC, # 02h ; middle left
	LEDS_EXIT

_afsk_rx_led
	LEDS_ENTER
	tste
	beq  L53
	ldd  # 500        ; 0.5 seconds
	std  led_delay    ; timer lives in bank F as well

	bset PORTC, # 04h ; bottom left
	LEDS_EXIT
L53
	bclr PORTC, # 04h ; bottom left
	LEDS_EXIT

_green_leds
	LEDS_ENTER
	lsre
	bcs  L61
	bclr PORTC, # 08h
	bra  L62
L61
	bset PORTC, # 08h
L62
	lsre
	bcs  L63
	bclr PORTC, # 10h
	bra  L64
L63
	bset PORTC, # 10h
L64
	lsre
	bcs  L65
	bclr PORTC, # 20h
	bra  L66
L65
	bset PORTC, # 20h
L66
	LEDS_EXIT


;-----------------------------------------------------------
	global _axcmp

_axcmp
	xgex
	xgdy
	clre
	ldaa  # 6
L67
	ldab  e,x
	eorb  e,y
	lsrb
	bne   L68
	adde  # 1
	deca
	bne   L67

	ldab  e,x
	eorb  e,y
	andb  # 1Eh
L68
	clra           ; 0 if equal
	rts

;-----------------------------------------------------------
	global _unpack_bcd_to_ascii

_unpack_bcd_to_ascii

	tsx
	ldx  4,x ; number of ascii digits
	beq  L6  ; should not happen

	xgex     ; X src in packed bcd, E digit count
	xgdy     ; Y dst in asciz
L5
	ldaa 0,x
	aix  #+1
	tab
	lsra
	lsra
	lsra
	lsra
	adda # 30h
	staa 0,y

	andb # 0Fh
	addb # 30h
	stab 1,y

	aiy  #+2
	sube #2
	bhi  L5  ; no carry, no zero
L6
	rts


;-----------------------------------------------------------
	global _repack_bcd_to_binary

_repack_bcd_to_binary

	xgex            ; buffer
	xgdy            ; byte count
L90
	ldaa 0,x        ; bcd              ---- 23--     ---- 99--
	tab             ;                  ???? 2323     ???? 9999
	andd # 0FF0h    ; ones and tens    ???? 0320     ???? 0990
	tde             ; save in E MSByte 0320 0320     0990 0990
	lsrb            ; nice             0320 0310     0990 0948
	tba             ;  shortcut        0320 1010     0990 4848
	lsrb            ;  for /= 16       0320 1008     0990 4824
	lsrb            ;  and *= 10       0320 1004     0990 4812
	aba             ; tens in binary   0320 1404     0990 5A12
	ade             ; merge with ones  1724 1404     63A2 5A12
	ted             ;                  1724 1724     63A2 63A2
	staa 0,x        ; binary           ---- 17--     ---- 63--

	aix  #+1
	aiy  #-1
	bne  L90
	rts


;-----------------------------------------------------------
	global _ld_word_intel, _ld_dword_intel
	global _ld_short_intel, _ld_long_intel

_ld_word_intel
_ld_short_intel

	xgex
	ldd  0,x
	xgab
	rts

_ld_dword_intel
_ld_long_intel

	xgex
	ldd  2,x
	xgab
	tde
	ldd  0,x
	xgab
	rts

;-----------------------------------------------------------
	global _SCALE32, _SCALE24, _SCALE16

_SCALE32          ; long SCALE32(long *E, long *D)

	pshm z
	ais  #-8      ; 4 words of scratch XXX return all 64 bits to caller
	tsz
	bsr  mullit

	lde  0,z      ; return 32 top bits of result
	ldd  2,z

	ais  #+8
	pulm z
	rts

_SCALE24          ; long SCALE24(long *E, long *D)

	pshm z
	ais  #-8      ; 4 words of scratch
	tsz
	bsr  mullit

	lde  1,z      ; drop 24 bits from result
	ldd  3,z

	ais  #+8
	pulm z
	rts

_SCALE16          ; long SCALE16(long *E, long *D)

	pshm z
	ais  #-8      ; 4 words of scratch
	tsz
	bsr  mullit

	lde  2,z      ; return 32 middle bits of result
	ldd  4,z

	ais  #+8
	pulm z
	rts

mullit

	xgex          ; long ab at X
	xgdy          ; long cd at Y

	ldd  2,y
	lde  2,x
	emul          ; bd low 32 bits
	std  6,z
	ste  4,z

	ldd  0,y
	lde  0,x
	emul          ; ac high 32 bits
	std  2,z
	ste  0,z

	ldd  2,y
	lde  0,x
	emul          ; ad in the middle
	bsr  addit

	ldd  0,y
	lde  2,x
	emul          ; bc in the middle

	; bsr  addit -  fall thru insted.

addit

	addd 4,z
	std  4,z
	adce 2,z
	ste  2,z
	bcc  L7
	incw 0,z
L7
	rts


;-----------------------------------------------------------
	global _RRC_byte, _RLC_byte

_RRC_byte
	ted          ; implicit clear A
	rore         ; old LSbit to carry
	rorb         ; push carry to B from left
	rts

_RLC_byte
	ted          ; implicit clear A
	addb #80h    ; push the old MSbit to carry
	rolb         ; push carry to B from right
	rts

	global _parity   ; byte/bool parity(word);

_parity
	ted          ; input is 16 bits
	pshm d       ; local word
	tsx          ; MSByte at 0,x
	eorb 0,x     ; folded to 8 bits
	stab 0,x
	lsrb
	lsrb
	lsrb
	lsrb
	eorb 0,x     ; folded to 4 bits
	stab 0,x
	lsrb
	lsrb
	eorb 0,x     ; folded to 2 bits
	stab 0,x
	lsrb
	eorb 0,x     ; folded to 1 bit
	andb # 1     ; clean it
	ais  #+2     ; purge
	rts

;-----------------------------------------------------------
	global _atol_signed   ; void atol_signed(long *result, char *str);

_atol_signed

	pshm  z
	ais   #-4
	tsz           ; Z to scratch

	xgey          ; Y to long
	xgdx          ; X to string

	clrw  2,y
	clrw  0,y
	clrw  0,z     ; scratch digit, MSByte always 0
L10
	ldab  0,x
	cmpb  # ' '
	bne   L11
	aix   #+1
	bra   L10     ; more blankskipping
L11
	cmpb  # '-'
	bne   L12
	aix   #+1
L12
	std   2,z     ; scratch sign
L13
	ldab  0,x
	subb  # '0'
	bcs   L14     ; below 0
	cmpb  # 9
	bhi   L14     ; above 9

	stab  1,z     ; 0 ... 9 to add after *= 10

	ldd   2,y
	lde   0,y
	asld
	role
	asld
	role
	addd  2,y
	adce  0,y     ; 5 times
	asld
	role          ; 10 times
	addd  0,z
	adce  # 0
	std   2,y
	ste   0,y

	aix   #+1
	bra   L13     ; more digits
L14
	ldd   2,z     ; was it negative ?
	cmpb  # '-'
	bne   L15
	clrd
	clre
	subd  2,y
	sbce  0,y
	std   2,y
	ste   0,y
L15
	ais   #+4
	pulm  z
	rts


;-----------------------------------------------------------

	global _sscan_02u   ; only arg - pointer in E
	global _sscan_03u

_sscan_02u

	xgex

	ldab 0,x
	subb # '0'
	ldaa # 10
	mul
	addb 1,x
	subb # '0'
	rts

_sscan_03u

	xgex

	ldab 0,x
	subb # '0'
	ldaa # 100
	mul
	tde
	ldab 1,x
	subb # '0'
	ldaa # 10
	mul
	ade
	ldab 2,x
	subb # '0'
	clra
	ade
	ted
	rts

;-----------------------------------------------------------

	global _sprint_02u   ; 1st arg - pointer in E
	global _sprint_03u   ; 2nd arg - number in D
	global _sprint_05u

_sprint_02u

	xgey

	ldx  # 10
	idiv          ; D / IX to IX
	addb # '0'    ; D receives remainder
	stab 1,y      ; ones

	xgdx
	addb # '0'
	stab 0,y      ; tens
	rts

_sprint_03u

	xgey

	ldx  # 10
	idiv
	addb # '0'
	stab 2,y      ; ones

	xgdx
	ldx  # 10
	idiv
	addb # '0'
	stab 1,y      ; tens

	xgdx
	addb # '0'
	stab 0,y      ; hundreds
	rts

_sprint_05u

	xgey

	ldx  # 10
	idiv
	addb # '0'
	stab 4,y      ; ones

	xgdx
	ldx  # 10
	idiv
	addb # '0'
	stab 3,y      ; tens

	xgdx
	ldx  # 10
	idiv
	addb # '0'
	stab 2,y      ; 100's

	xgdx
	ldx  # 10
	idiv
	addb # '0'
	stab 1,y      ; 1000's

	xgdx
	addb # '0'
	stab 0,y      ; 10'000's
	rts

;-----------------------------------------------------------
decades
	dc.l 1000000000
	dc.l 100000000
	dc.l 10000000
	dc.l 1000000
	dc.l 100000
	dc.l 10000
	dc.l 1000
	dc.l 100
	dc.l 10
decadend

	global _sprint_010Lu

_sprint_010Lu

	pshm k,z

	xgey            ; dst in IY
	xgdz            ; &number in IZ

	ldd  # __text_page
	tbxk            ; XK:IX for the constants
	ldx  # decades

	lde  0,z
	ldd  2,z        ; number in ED
L16
	ldz  # '0' - 1  ; adjusted for one increment too many
L17
	aiz  #+1        ; next digit - no danger of ZK wrap
	subd 2,x
	sbce 0,x
	bcc  L17        ; while at or over the decade

	addd 2,x
	adce 0,x        ; undo last sub

	xgdz
	stab 0,y        ; another digit
	aiy  #+1        ; bump dst pointer
	xgdz
	aix  #+4        ; next decade
	cpx  # decadend
	bcs  L16        ; while they last

	addb # '0'      ; finally the ones
	stab 0,y
	clr  1,y        ; "C" terminator \0

	pulm k,z
	rts

;-----------------------------------------------------------
	                               ; extern long gps_altitude;
	global _sted_gps_altitude      ; void (long *E)
_sted_gps_altitude
	xgex
	lde   0,x
	ldd   2,x
	sted  _gps_altitude
	rts

;-----------------------------------------------------------
;	global _link_list_tail
;
;_link_list_tail    ; struct * (struct **pp_E); 'next' must be 1st in struct
;
;	xgex           ; pp
;L42
;	txy            ; tentative return value
;	ldx  0,x       ; pp = (*pp)->next
;	bne  L42       ; do while
;L43
;	xgdy           ; retun value
;	rts
;
;-----------------------------------------------------------

	end
