
#define STATIC static

typedef unsigned char  byte;
typedef unsigned char  bool;
typedef unsigned short word;
typedef unsigned long  stamp;
typedef unsigned long  dword;

word time_since(stamp *);
word bolt(void);
void now(stamp *);
void future_msec(stamp *, word msec);
void future_sec(stamp *, word sec);

bool time_past(stamp);

void delay_ms(word millisec);

word read_inputs();

/* XXX pin(0) is cpu pin 0, D25 pin +V XXX konfutseus */

void CTS1_pin(word set);
void CTS2_pin(word dont_clr);
void DCD1_pin(word set);
void DCD2_pin(word dont_clr);
void DSR1_pin(word set);
void DSR2_pin(word set);

bool DTR1_pin(void);
bool DTR2_pin(void);
bool RTS1_pin(void);
bool RTS2_pin(void);

extern const word word_bitmask[];
extern const byte byte_bitmask[];

#define spl0() asm("andp #0FF1Fh")
#define spl7() asm("orp  #000E0h")

word  ld_word_intel(void *);
dword ld_dword_intel(void *);
short ld_short_intel(void *);
long  ld_long_intel(void *);

bool busy_channel();
word read_rssi();

void ASLx(dword *, word nbits);
void LSRx(dword *, word nbits);

word RRC_byte(word); /* using 'word' seems odd, but helps cc a lot */
word RLC_byte(word);

long EMUL(word, word);
word EDIV(long, word, word *rem);
long EMULx(long, word);
long EDIVx(long, word, word *rem);
long EDIVx_signed(long, word, word *rem);

word muldiv(word value, word mul, word div);

long SCALE16(long *, long *);
long SCALE24(long *, long *);
long SCALE32(long *, long *);
long SCALE32_signed(long *, long *);

#define FALSE 0
#define TRUE  1
#define NULL  ((void *) 0)
#define EOF   (-1)

#define BLANK ' '
#define COMMA ','
#define DOT   '.'

#define __SIZEOF(arr) (sizeof(arr) / sizeof((arr)[0]))

byte *prompt(byte *);
bool more(int *);

int  printf(char *, ...); /* ... puts all args on stack */
void putchar(byte);
byte getchar();
bool ischar();
void doh(char *what);
void eol(), blank();
word isqrt(dword);
word ihypot(word, word);
word iatan2(long, long);

char *itoa(char *buf, int bsize, word i);
char *ltoa(char *buf, int bsize, dword l);

bool  isdigit(byte);
bool  isalnum(byte);
bool  wildmat(char *pat, char *);

int   char_cmp_no_case(byte, byte);
byte  toupper(byte);
byte  tolower(byte);
int   strcasecmp(byte *, byte *);
int   strcmp(byte *, byte *);
int   strncmp(byte *, byte *, int size);
byte *strcpyx(byte *, byte *);
void  strupper(byte *);
void  strlower(byte *);
void  strcat(byte *, byte *);
int   strlen(byte *);
void  strncpyx(byte *dst, byte *src, int size);
void  bzero(void *, int cc);
void  bcopy(const void *vsrc, void *vdst, int cc);
int   bcmp(const void *, const void *, int cc);

void print_byte(byte);
void print_word(word);
void print_dword(dword *);
void print_buf(const byte *, int cc);
void print_string(const byte *);
void print_short(word);
void print_short_N(word, short width);
void print_signed_short(short);
void print_signed_long(long *);

word ascii_hex(byte *str, int len);
int  atoi(const byte *str);

void atol_signed(long *, char *str);

word  abs(short);
dword labs(long);
long  lnegate(long);

void sprint_02u(byte *, word);
void sprint_03u(byte *, word);
void sprint_05u(byte *, word);
void sprint_03d_signed(byte *, short);
void sprint_06Lu(byte *, dword *);
void sprint_010Lu(byte *, dword *);
void sprint_lat(byte *, long *);
void sprint_lon(byte *, long *);

